/**
 * @(#) DataFileContent; class to express TimeControl
 *
 */

package ohymosj;

import ohymosj.*;
import java.util.*;
import java.io.*;


/**
 * <japanese>
 * f[^t@C̓e\NXłB<p>
 *
 * ^ɈSȒ萔̃NXłB<p>
 *
 * <ul>
 *  <li> PARSET :
 *   <dd>  f[^t@CɃp^L^ĂB
 *  <li> INITIAL :
 *   <dd>  f[^t@CɏԗʂL^ĂB
 *  <li> SDPDATA :
 *   <dd>  f[^t@CɑM[qɎcĂf[^L^ĂB
 * </ul>
 * <p>
 *
 * <a href="OhTotalSystem.html#deliverDataString(java.lang.String, DataFileContent)">OhTotalSystem.deliverDataString(String, DataFileContent)</a> 
 * gpĂ܂B
 * </japanese>
 * <p>
 * DataFileContent;
 *
 * DataFileContent class. <p>
 *
 * Definition of DataFileContent
 * <dl>
 *  <dt>PARSET:  <dd>Parameter values are contained in the file.
 *  <dt>INITIAL: <dd>Initial state values are contained in the file.
 *  <dt>SDPDATA: <dd>Send port datapacks are contained in the file.
 * </dl>
 *
 * @author <a href="mailto:satoh@wr.kuciv.kyoto-u.ac.jp">satoh</a>
 * @version $Revision: 1.12 $ $Date: 2004/02/12 05:35:33 $
 */
public final class DataFileContent implements Serializable
{
  // @begin {instance variable or static variable} -----------------------

  private static int nextOrdinal = 0;
  private final  int ordinal     = nextOrdinal++;

  /**
   * <japanese>
   * f[^t@CɃp^L^Ă邱Ƃ\^ɈSȒ萔łB
   * </japanese>
   * <p>
   * PARSET: <br>
   * Parameter values are contained in the file.
   *
   */
  public static final DataFileContent PARSET  = new DataFileContent();

  /**
   * <japanese>
   * f[^t@CɏԗʂL^Ă邱Ƃ\^ɈSȒ萔łB
   * </japanese>
   * <p>
   * INITIAL: <br>
   * Initial state values are contained in the file.
   *
   */
  public static final DataFileContent INITIAL = new DataFileContent();

  /**
   * <japanese>
   * f[^t@CɑM[qɎcĂf[^L^Ă邱Ƃ\^ɈSȒ萔łB
   * </japanese>
   * <p>
   * SDPDATA: <br>
   * Send port datapacks are contained in the file.
   *
   */
  public static final DataFileContent SDPDATA = new DataFileContent();

  private static final DataFileContent[] PRIVATE_VALUES = {PARSET, INITIAL, SDPDATA};
  
  // @end {instance variable or static variable} -------------------------
  
  
  // @begin {constructors} -----------------------------------------------
  
  private DataFileContent() {}

  // @end {constructors} -------------------------------------------------

  
  // @begin {methods} ----------------------------------------------------

  private Object readResolve() throws ObjectStreamException {
    return PRIVATE_VALUES[ordinal];
  }

  // @end {methods} ------------------------------------------------------

} // DataFileContent
