/**
 * @(#) OhArrayList;
 *
 */

package ohymosj;

import ohymosj.*;
import java.util.*;
import java.io.*;

/**
 * <japanese>
 * NX ArrayList pč쐬z񃊃XgNXłB
 * </japanese>
 *
 * @author <a href="mailto:satoh@wr.kuciv.kyoto-u.ac.jp">satoh</a>
 * @version $Revision: 1.11 $ $Date: 2004/02/10 15:48:17 $
 */
public class OhArrayList extends ArrayList {

  // @begin{field} -------------------------------------------------------

  /**
   * <japanese>
   * CfbNXłB
   * </japanese>
   *
   */
  protected int _startIndex;

  // @end{field} ---------------------------------------------------------


  // @begin{constructor} -------------------------------------------------

  /**
   * <japanese>
   * _startIndex  0 ̋̃Xg쐬܂B
   * </japanese>
   *
   */
  public OhArrayList() {
    _startIndex = 0;
  }

  // @end{constructor} ---------------------------------------------------

  
  // @begin{methods} -----------------------------------------------------

  /**
   * <japanese>
   * _startIndex  aStartIndex ɐݒ肵܂B
   * </japanese>
   *
   * @param aStartIndex an <code>int</code> value
   */
  public void setStartIndex(int aStartIndex) {
    _startIndex = aStartIndex;
  }
  
  /**
   * <japanese>
   * _startIndex Ԃ܂B
   * </japanese>
   *
   * @return an <code>int</code> value
   */
  public int getStartIndex() {
    return _startIndex;
  }

  /**
   * <japanese>
   * Xg̍Ō̗vfԂ܂B
   * </japanese>
   *
   * @return an <code>Object</code> value
   */
  public Object getLastElement() {
    return get(size() - 1);
  }

  /**
   * <japanese>
   * ̃XgAfromIndex Ŏn܂ toIndex ̒OŏICfbNXׂĂ̗vf폜܂B
   * 㑱̗vf͍Ɉړ܂(CfbNXl)B
   * ̌Ăяo ArrayList  (toIndex - fromIndex) ̗vfZk܂B
   * toIndex==fromIndex ̏ꍇÃIy[Vɂ͉e͂܂B
   * </japanese>
   *
   * @param aFrom an <code>int</code> value
   * @param aTo an <code>int</code> value
   */
  public void removeRange(int aFrom, int aTo) {
    super.removeRange(aFrom, aTo);
  }


  /**
   * <japanese>
   * ̃XgAŏ̗vf aIndex ̒OŏICfbNXׂĂ̗vf폜A
   * _startIndex  0 ɐݒ肵܂B
   * AaIndex  _startIndex 菬ꍇ͉ɖ߂܂B
   * ܂AaIndex Ɏw肵lvf 1/4 ȉ̏ꍇA
   * _startIndex ̒l aIndex ɐݒ肵Ė߂܂B
   * </japanese>
   *
   * @param aIndex an <code>int</code> value
   */
  public void removeHeadRange(int aIndex) {
    if (aIndex < _startIndex) {
      return;
    }
    else if (aIndex < (size()/4)) {
      _startIndex = aIndex;
      return;
    }
    else {
      removeRange(0, aIndex);
      _startIndex = 0;
    }
  }

  // @end{methods} --------------------------------------------------------

} // OhArrayList
