/**
 * @(#) OhOption; Declaration of OHyMoSJ option variables.
 *
 */

package ohymosj;

import ohymosj.*;
import java.io.*;

/**
 * <japanese>
 * OHyMoSJ ɂV~[VŜ̃IvV\NXłB<p>
 *
 * OHyMoSJ ɂV~[VŜɊւIvV̎w舵܂B
 * IvV́ÃNX̃oϐ̒lŎw肵܂B
 * ̓Iɂ́A<p>
 *
 * <ul>
 *  <li> <a href="TimeControl.html">TimeControl</a> ɊւIvV
 *  <li> GUI ̎gpɊւIvV
 * </ul>
 *
 * 舵Ă܂B<p>
 *
 * ftHg̃IvV́A<p>
 *
 * <ul>
 *  <li> <a href="TimeControl.html">TimeControl</a> _tc = TimeControl.GO_BEYOND_TERMINAL_TIME;
 *   <dd>  ԖڕW𒴂ČvZB
 *  <li> boolean _useWinP = false;
 *   <dd>  GUI gpȂB
 * </ul>
 *
 * ̂悤Ɏw肳Ă܂B<p>
 *
 * ܂ÃNX singlton NXłB
 * OhOption  singlton 擾ɂ́A
 *
 * <pre>
 *  OhOption.getDefault().<method>;
 * </pre>
 *
 * Ƃ܂B<p>
 *
 * <a href="OhTotalSystem.html#setOhymosjOption()">OhTotalSystem.setOhymosjOption()</a> ̗͂łāA
 * vOs[UC^NeBuɃIvVw肷郁\bhłB
 *
 * </japanese>
 * <p>
 *
 * OhOption;
 *
 * OhymosOption treats specification of general options for simulation.
 * 
 * @author <a href="mailto:satoh@wr.kuciv.kyoto-u.ac.jp">satoh</a>
 * @version $Revision: 1.15 $ $Date: 2004/02/12 05:56:35 $
 */
public class OhOption
{
  /**
   * <japanese>
   * OHyMoSJIvṼVOgłB
   * </japanese>
   * <p>
   * The singlton of the OHyMoSJ option.
   *
   */
  private static OhOption instance = null;

  /**
   * <japanese>
   * GUI ̎gpɊւIvVłB<p>
   *
   * ftHǵA
   *
   * <pre>
   *  _useWinP = false;
   * </pre>
   *
   * Ȃ킿AGUI gpȂ悤ɐݒ肳Ă܂B
   * </japanese>
   * <p>
   * Option about use of GUI.
   *
   */
  protected boolean _useWinP = false;

  /**
   * <japanese>
   * <a href="TimeControl.html">TimeControl</a> ɊւIvVłB<p>
   *
   * ftHǵA
   *
   * <pre>
   *  _tc = TimeControl.GO_BEYOND_TERMINAL_TIME;
   * </pre>
   *
   * Ȃ킿AԖڕW𒴂ČvZ悤ɐݒ肳Ă܂B
   * </japanese>
   * <p>
   * Option about <a href="TimeControl.html">TimeControl</a>.
   *
   */
  protected TimeControl _tc = TimeControl.GO_BEYOND_TERMINAL_TIME;

  /**
   * Creates a new default <code>OhOption</code> instance.
   *
   */
  protected OhOption () {
    super();
  }

  /**
   * <japanese>
   * OHyMoSJIvṼVOg擾܂BNX\bhłB
   * </japanese>
   *
   * @return an <code>OhOption</code> value
   */
  public static OhOption getDefault() {
    if (instance == null) {
      instance = new OhOption();
    }
    return instance;
  }

  /**
   * <japanese>
   * GUI ̎gpɊւIvVݒ肵܂B<p>
   *
   * ftHgł GUI gpȂ悤ɐݒ肳Ă̂ŁA
   *  aUseWinP  true w肵Ă
   * GUI gp[hɂȂ܂B
   * </japanese>
   *
   * @param aUseWinP a <code>boolean</code> value
   */
  public void setUseWinP(boolean aUseWinP) {
    _useWinP = aUseWinP;
  }
  
  /**
   * <japanese>
   * GUI ̎gpɊւIvVԂ܂B
   *
   * GUI gpȂꍇ falseAGUI gpꍇ true Ԃ܂B
   * </japanese>
   *
   * @return a <code>boolean</code> value
   */
  public boolean getUseWinP() {
    return _useWinP;
  }
  
  /**
   * <japanese>
   * <a href="TimeControl.html">TimeControl</a> ɊւIvVݒ肵܂B<p>
   *
   * ftHgł͒ԖڕW𒴂ČvZ悤ɐݒ肳Ă̂ŁA
   *  aTc 
   * <a href="TimeControl.html#DO_NOT_GO_BEYOND_TERMINAL_TIME">TimeControl.DO_NOT_GO_BEYOND_TERMINAL_TIME</a> 
   * w肵ĂƒԖڕW𒴂ɌvZ悤ɐݒ肳܂B
   * </japanese>
   *
   * @param aTc a <code>TimeControl</code> value
   */
  public void setTimeControlOption(TimeControl aTc) {
    _tc = aTc;
  }
  
  /**
   * <japanese>
   * <a href="TimeControl.html">TimeControl</a> ɊւIvVԂ܂B <p>
   *
   * ԖڕW𒴂ČvZꍇ
   * <a href="TimeControl.html#GO_BEYOND_TERMINAL_TIME">TimeControl.GO_BEYOND_TERMINAL_TIME</a>A
   * ԖڕW𒴂ɌvZꍇ
   * <a href="TimeControl.html#DO_NOT_GO_BEYOND_TERMINAL_TIME">TimeControl.DO_NOT_GO_BEYOND_TERMINAL_TIME</a> 
   * Ԃ܂B
   * </japanese>
   *
   * @return a <code>TimeControl</code> value
   */
  public TimeControl getTimeControlOption() {
    return _tc;
  }

} // OhOption
