/**
 * @(#) OhRelayDouble; class to express a port which relays datapacks of type double.
 *
 */

package ohymosj;

import ohymosj.*;
import java.util.*;
import java.io.*;

/**
 * <japanese>
 * f[^l double ^̃f[^pbN𒆌p钆p[q\NXłB
 * <a href="OhSenderPort.html">OhSenderPort</a> pč쐬鑗M[q̃NXłB
 * </japanese>
 * <p>
 *
 * OhRelayDouble;
 *
 * OhRelayDouble is a class of port which relays datapacks of type double.
 *
 * @author <a href="mailto:satoh@wr.kuciv.kyoto-u.ac.jp">satoh</a>
 * @version $Revision: 1.14 $ $Date: 2004/02/11 22:52:00 $
 */
public class OhRelayDouble extends OhRelayPort
{
  // @begin{initialization} ----------------------------------------------

  /**
   * <japanese>
   * IuWFNgAIuWFNgԍ܂B
   * </japanese>
   * <p>
   * Initialization.
   *
   * @param aPortName a <code>String</code> value
   * @param aPortNum an <code>int</code> value
   * @return a <code>boolean</code> value
   * @exception OhError if an error occurs
   */
  public boolean init(String aPortName, int aPortNum) throws OhError {
    return super.init(aPortName, aPortNum);
  }

  // @end{initialization} ------------------------------------------------
  
  
  // @begin {constructors} -----------------------------------------------

  /**
   * <japanese>
   * ftHgRXgN^
   * <a href="OhRelayDouble.html#init(String, int)">OhRelayDouble.init(String, int)</a> s܂B
   * ̌ʁAȉ̐ݒƂȂ܂B<p>
   *
   * <dl>
   *  <li> _objectName        : null
   *  <li> _objectNumber      : -1
   * </dl>
   *
   * <p>
   * ̑̃oϐɑ΂鏈͈RXgN^ƓłB
   * ̏ꍇA<a href="OhRelayDouble.html#init(String, int)">OhRelayDouble.init(String, int)</a> 
   * păoϐĉB
   * </jananese>
   * Creates a new default <code>OhRelayDouble</code> instance.
   *
   * @exception OhError if an error occurs
   */
  public OhRelayDouble() throws OhError {
    super();
    _className = "OhRelayDouble";
  }

  
  /**
   * <japanese>
   * NX̃RXgN^
   * <a href="OhRelayPort.html#OhRelayPort.OhRelayPort(String, int)">OhRelayPort.OhRelayPort(String, int)</a>
   * ̃RXgN^păoϐȉ̒ʂ菉܂B<p>
   *
   * <dl>
   *  <li> _className         : "OhRelayDouble"
   *  <li> _objectName        : aPortName
   *  <li> _objectNumber      : aPortNum
   *  <li> _owner             : null
   *  <li> _bufferList        : ɊmۂBiڑƗpj
   *  <li> _receiverArray     : null
   *  <li> _numberOfReceivers : -1
   *  <li> _sender            : null
   * </dl>
   * </japanese>
   *
   * @param aPortName a <code>String</code> value
   * @param aPortNum an <code>int</code> value
   * @exception OhError if an error occurs
   */
  public OhRelayDouble(String aPortName, int aPortNum) throws OhError {
    super(aPortName, aPortNum);
    _className = "OhRelayDouble";
  }

  // @end {constructors} -------------------------------------------------

  
  // @begin {methods} ----------------------------------------------------

  /**
   * <japanese>
   * pf[^pbÑf[^ľ^ double \ "double" Ԃ܂B
   * </japanese>
   * <p>
   * Returns the data pack type which expresses the type of data to be relayed.
   *
   * @return a <code>String</code> value
   */
  public String dataType() {
    return "double";
  }

  // @end {methods} ------------------------------------------------------

} // OhRelayDouble
