/**
 * @(#) OhRelayFloat; class to express a port which relays datapacks of type float.
 *
 */

package ohymosj;

import ohymosj.*;
import java.util.*;
import java.io.*;

/**
 * OhRelayFloat;
 *
 * OhRelayFloat is a class of port which relays datapacks of type float.
 *
 * @author <a href="mailto:satoh@wr.kuciv.kyoto-u.ac.jp">satoh</a>
 * @version $Revision: 1.2 $ $Date: 2004/01/17 13:40:48 $
 */
public class OhRelayFloat extends OhRelayPort
{
  // @begin{initialization} ----------------------------------------------

  /**
   * Initialization.
   *
   * @param aPortName a <code>String</code> value
   * @param aPortNum an <code>int</code> value
   * @return a <code>boolean</code> value
   * @exception OhError if an error occurs
   */
  public boolean init(String aPortName, int aPortNum) throws OhError {
    return super.init(aPortName, aPortNum);
  }

  // @end{initialization} ------------------------------------------------
  
  
  // @begin {constructors} -----------------------------------------------

  /**
   * Creates a new default <code>OhRelayFloat</code> instance.
   *
   * @exception OhError if an error occurs
   */
  public OhRelayFloat() throws OhError {
    super();
    _className = "OhRelayFloat";
  }

  
  /**
   * Creates a new <code>OhRelayFloat</code> instance.
   *
   * @param aPortName a <code>String</code> value
   * @param aPortNum an <code>int</code> value
   * @exception OhError if an error occurs
   */
  public OhRelayFloat(String aPortName, int aPortNum) throws OhError {
    super(aPortName, aPortNum);
    _className = "OhRelayFloat";
  }

  // @end {constructors} -------------------------------------------------

  
  // @begin {methods} ----------------------------------------------------

  /**
   * Returns the data pack type which expresses the type of data to be received.
   *
   * @return a <code>String</code> value
   */
  public String dataType() {
    return "float";
  }


  // copy method.

  /**
   * Copy method.
   *
   * @param aRd an <code>OhRelayFloat</code> value
   */
  public void copy(OhRelayFloat aRd) {
    _className    = aRd._className;
    _objectName   = aRd._objectName;
    _objectNumber = aRd._objectNumber;
    _owner        = aRd._owner;

    _bufferList        = aRd._bufferList;
    _receiverArray     = aRd._receiverArray;
    _numberOfReceivers = aRd._numberOfReceivers;
    _commentString     = aRd._commentString;

    _sender = aRd._sender;
  }
  
  // @end {methods} ------------------------------------------------------

} // OhRelayFloat
