/**
 * @(#) OhRelayLong; class to express a port which relays datapacks of type long.
 *
 */

package ohymosj;

import ohymosj.*;
import java.util.*;
import java.io.*;

/**
 * OhRelayLong;
 *
 * OhRelayLong is a class of port which relays datapacks of type long.
 *
 * @author <a href="mailto:satoh@wr.kuciv.kyoto-u.ac.jp">satoh</a>
 * @version $Revision: 1.1 $ $Date: 2004/01/17 02:09:41 $
 */
public class OhRelayLong extends OhRelayPort
{
  // @begin{initialization} ----------------------------------------------

  /**
   * Initialization.
   *
   * @param aPortName a <code>String</code> value
   * @param aPortNum an <code>int</code> value
   * @return a <code>boolean</code> value
   * @exception OhError if an error occurs
   */
  public boolean init(String aPortName, int aPortNum) throws OhError {
    return super.init(aPortName, aPortNum);
  }

  // @end{initialization} ------------------------------------------------
  
  
  // @begin {constructors} -----------------------------------------------

  /**
   * Creates a new default <code>OhRelayLong</code> instance.
   *
   * @exception OhError if an error occurs
   */
  public OhRelayLong() throws OhError {
    super();
    _className = "OhRelayLong";
  }

  
  /**
   * Creates a new <code>OhRelayLong</code> instance.
   *
   * @param aPortName a <code>String</code> value
   * @param aPortNum an <code>int</code> value
   * @exception OhError if an error occurs
   */
  public OhRelayLong(String aPortName, int aPortNum) throws OhError {
    super(aPortName, aPortNum);
    _className = "OhRelayLong";
  }

  // @end {constructors} -------------------------------------------------

  
  // @begin {methods} ----------------------------------------------------

  /**
   * Returns the data pack type which expresses the type of data to be received.
   *
   * @return a <code>String</code> value
   */
  public String dataType() {
    return "long";
  }


  // copy method.

  /**
   * Copy method.
   *
   * @param aRd an <code>OhRelayLong</code> value
   */
  public void copy(OhRelayLong aRd) {
    _className    = aRd._className;
    _objectName   = aRd._objectName;
    _objectNumber = aRd._objectNumber;
    _owner        = aRd._owner;

    _bufferList        = aRd._bufferList;
    _receiverArray     = aRd._receiverArray;
    _numberOfReceivers = aRd._numberOfReceivers;
    _commentString     = aRd._commentString;

    _sender = aRd._sender;
  }
  
  // @end {methods} ------------------------------------------------------

} // OhRelayLong
