/**
 * @(#) OhSendDouble; class to express a port which send datapacks of type double.
 *                    Make "OhSendDouble.java" from "ohp_tmp.h" and "ohp_tmp.cpp" by Satoh.
 */

package ohymosj;

import ohymosj.*;
import java.util.*;
import java.io.*;

/**
 * <japanese>
 * f[^l double ^̃f[^pbN𑗐M鑗M[q\NXłB<p>
 *
 * <a href="OhSendPort.html">OhSendPort</a> pč쐬鑗M[q̃NXłB
 * </japanese>
 * <p>
 *
 * OhSendDouble;
 *
 * OhSendDouble is the base class to express a port which send double data.
 *
 *
 * @author <a href="mailto:satoh@wr.kuciv.kyoto-u.ac.jp">satoh</a>
 * @version $Revision: 1.28 $ $Date: 2004/02/12 04:08:42 $
 */
public class OhSendDouble extends OhSendPort
{
  // @begin{initialization} ----------------------------------------------

  /**
   * <japanese>
   * IuWFNgAIuWFNgԍA
   * f[^̕Ԃ͐܂ɐݒ肵܂B
   * ̓Iɂ́A
   * _dctVec ̑vf
   * <a href="DataConnectionType.html#BROKENLINE">DataConnectionType.BROKENLINE</a> i[܂B
   * </japanese>
   * <p>
   * Initialization.
   *
   * @param aPortName a <code>String</code> value
   * @param aPortNum an <code>int</code> value
   * @return a <code>boolean</code> value
   */
  public boolean init(String aPortName, int aPortNum) throws OhError {
    return super.init(aPortName, aPortNum);
  }

  /**
   * <japanese>
   * IuWFNgAIuWFNgԍAf[^Ԍ^xNg܂B
   * </japanese>
   * <p>
   * Initialization.
   *
   * @param aPortName a <code>String</code> value
   * @param aPortNum an <code>int</code> value
   * @param aDctVec a <code>Vector</code> value
   * @return a <code>boolean</code> value
   */
  public boolean init(String aPortName, int aPortNum, Vector aDctVec) throws OhError {
    return super.init(aPortName, aPortNum, aDctVec);
  }

  // @end{initialization} ------------------------------------------------

  
  // @begin {constructors} -----------------------------------------------
  
  /**
   * <japanese>
   * ftHgRXgN^
   * <a href="OhSendDouble.html#init(String, int)">OhSendDouble.init(String, int)</a> s܂B
   * ̌ʁAȉ̐ݒƂȂ܂B<p>
   *
   * <dl>
   *  <li> _objectName        : null
   *  <li> _objectNumber      : -1
   *  <li> _dctVec            : null
   * </dl>
   *
   * <p>
   * ̑̃oϐɑ΂鏈͈RXgN^ƓłB
   * ̏ꍇA<a href="OhSendDouble.html#init(String, int)">OhSendDouble.init(String, int)</a> 
   * păoϐĉB
   * </jananese>
   *
   * @exception OhError if an error occurs
   */
  public OhSendDouble() throws OhError {
    super();
    _className = "OhSendDouble";
  }


  /**
   * <japanese>
   * NX̃RXgN^
   * <a href="OhSendPort.html#OhSendPort.OhSendPort(String, int)">OhSendPort.OhSendPort(String, int)</a>
   * ̃RXgN^păoϐȉ̒ʂ菉܂B<p>
   *
   * <dl>
   *  <li> _className         : "OhSendDouble"
   *  <li> _objectName        : aPortName
   *  <li> _objectNumber      : aPortNum
   *  <li> _owner             : null
   *  <li> _bufferList        : ɊmۂBiڑƗpj
   *  <li> _receiverArray     : null
   *  <li> _numberOfReceivers : -1
   *  <li> _dataPackArray     : null
   *  <li> _numberOfDataPacks : -1
   *  <li> _dctVec            : null
   * </dl>
   * </japanese>
   *
   * @param aPortName a <code>String</code> value
   * @param aPortNum an <code>int</code> value
   * @exception OhError if an error occurs
   */
  public OhSendDouble(String aPortName, int aPortNum) throws OhError {
    super(aPortName, aPortNum);
    _className = "OhSendDouble";
  }

  
  /**
   * <japanese>
   * NX̃RXgN^
   * <a href="OhSendPort.html#OhSendPort.OhSendPort(String, int, Vector)">OhSendPort.OhSendPort(String, int, Vector)</a>
   * ̃RXgN^păoϐȉ̒ʂ菉܂B<p>
   *
   * <dl>
   *  <li> _className         : "OhSendDouble"
   *  <li> _objectName        : aPortName
   *  <li> _objectNumber      : aPortNum
   *  <li> _owner             : null
   *  <li> _bufferList        : ɊmۂBiڑƗpj
   *  <li> _receiverArray     : null
   *  <li> _numberOfReceivers : -1
   *  <li> _dataPackArray     : null
   *  <li> _numberOfDataPacks : -1
   *  <li> _dctVec            : aDctVec
   * </dl>
   * </japanese>
   *
   * @param aPortName a <code>String</code> value
   * @param aPortNum an <code>int</code> value
   * @param aDctVec a <code>Vector</code> value
   * @exception OhError if an error occurs
   */
  public OhSendDouble(String aPortName, int aPortNum, Vector aDctVec) throws OhError {
    super(aPortName, aPortNum, aDctVec);
    _className = "OhSendDouble";
  }

  // @end {constructors} -------------------------------------------------


  // @begin {methods} ----------------------------------------------------

  // 1. function for sending data.
  
  /**
   * <japanese>
   * Mf[^pbÑf[^ľ^ double \ "double" Ԃ܂B
   * </japanese>
   * <p>
   * Returns the data pack type which expresses the type of data to be received.
   *
   * @return a <code>String</code> value
   */
  public String dataType() {
    return "double";
  }


  /**
   * <japanese>
   * ɂƂ aT, aValue 
   * <a href="OhDataPackDouble.html">OhDataPackDouble</a> ^f[^pbN쐬A
   * <a href="OhSendPort.html#dataPackStock(Object)">OhSendPort.dataPackStock(Object)</a> p
   * M[qɑM܂B
   * </japanese>
   * <p>
   * Send data whose data time is "aT" and data value is "aValue".
   *
   * @param aT an <code>OhTimePoint</code> value
   * @param aValue a <code>double</code> value
   */
  public void sendData(OhTimePoint aT, double aValue) {    //; (*1)
    
    OhDataPackDouble dpd = new OhDataPackDouble();

    OhTimePoint tp = new OhTimePoint();  //; For work.
    tp.copy(aT);
    
    dpd.setData(tp, aValue);
    
    dataPackStock(dpd);
  }


  /**
   * <japanese>
   * ɂƂ aDataStr ŕ\ꂽf[^pbN
   * <a href="OhDataPackDouble.html">OhDataPackDouble</a> ^f[^pbN쐬A
   * <a href="OhSendPort.html#dataPackStock(Object)">OhSendPort.dataPackStock(Object)</a> p
   * M[qɑM܂B
   * </japanese>
   * <p>
   * Send data of type double whose value is stored in "aDataStr".
   *
   * @param aDataStr a <code>String</code> value
   */
  public void sendByString(String aDataStr) {           //; (*2)
    OhDataPackDouble dp = new OhDataPackDouble(aDataStr);
    dataPackStock(dp);
  }
    
  // @end {methods} ------------------------------------------------------

} // OhSendDouble
