/**
 * @(#) TimeControl; class to express TimeControl.
 *                   Make "TimeControl.java" from "ohoption.h" by Satoh.
 */

package ohymosj;

import ohymosj.*;
import java.util.*;
import java.io.*;


/**
 * <japanese>
 * ԖڕW𒴂ČvZ邩ۂ\NXłB<p>
 *
 * ^ɈSȒ萔̃NXłB<p>
 *
 * <ul>
 *  <li> GO_BEYOND_TERMINAL_TIME :
 *   <dd>  ԖڕW𒴂ČvZB
 *  <li> DO_NOT_GO_BEYOND_TERMINAL_TIME :
 *   <dd>  ԖڕW𒴂ɌvZB
 * </ul>
 *
 * ԖڕWƂ́A
 * ڕW <a href="OhTotalSystem.html#_terminalTime">OhTotalSystem._terminalTime</a> ȑO
 * iʂȏꍇƂāA<a href="OhTotalSystem.html#_terminalTime">OhTotalSystem._terminalTime</a> 
 * vĂ悢j̎ŁASĂ̗vf͂̎𒴂邱ƂڕWɌvZi߂ĂƂłB<p>
 *
 * ԖڕẂA
 * <a href="OhTotalSystem.html">OhTotalSystem</a> ̃oϐ
 * <a href="OhTotalSystem.html#_mediumTermTargetTime">OhTotalSystem._mediumTermTargetTime</a> Ƃ
 * ^Ă܂B<p>
 *
 * <a href="OhTotalSystem.html#_terminalTime">OhTotalSystem._terminalTime</a> ȑOɒԖڕWݒ肵A
 * SĂ̗vf͒ԖڕW܂ŌvZΐ摖肹A
 * ̗vf̌vZ҂悤ɂ̂悤ɂĂ܂B<p>
 *
 * ܂AԖڕW̓ɂāAŠn̗vfׂĂŌvZi߂lɂȂłȂA
 * ʂ̍팸}܂B
 * ܂AvfXgbNĂ˂΂ȂȂf[^pbŃA
 * ԖڕW玟̒ԖڕW܂ł̎ԕł悭A
 * vZԂɂĎgpʂϓ邱ƂȂȂƍl܂B
 * </japanese>
 * <p>
 * TimeControl;
 *
 * TimeControl class. <p>
 *
 * Definition of TimeControl. <p>
 *
 * <ul>
 *  <li> GO_BEYOND_TERMINAL_TIME        : Can go beyond the teminal time
 *  <li> DO_NOT_GO_BEYOND_TERMINAL_TIME : Cannot go beyond the terminal time
 * </ul>
 *
 * @author <a href="mailto:satoh@wr.kuciv.kyoto-u.ac.jp">satoh</a>
 * @version $Revision: 1.9 $ $Date: 2004/02/10 14:19:13 $
 */
public final class TimeControl implements Serializable
{
  // @begin {instance variable or static variable} -----------------------

  private static int nextOrdinal = 0;
  private final  int ordinal     = nextOrdinal++;

  /**
   * <japanese>
   * ԖڕW𒴂ČvZ邱Ƃ\^ɈSȒ萔łB
   * </japanese>
   * <p>
   * GoBeyondTerminalTime: <br>
   * Can go beyond the teminal time
   *
   */
  public static final TimeControl GO_BEYOND_TERMINAL_TIME = new TimeControl();

  /**
   * <japanese>
   * ԖڕW𒴂ɌvZ邱Ƃ\^ɈSȒ萔łB
   * </japanese>
   * <p>
   * DoNotGoBeyondTerminalTime: <p>
   * Cannot go beyond the terminal time
   *
   */
  public static final TimeControl DO_NOT_GO_BEYOND_TERMINAL_TIME = new TimeControl();

  private static final TimeControl[] PRIVATE_VALUES = {GO_BEYOND_TERMINAL_TIME, DO_NOT_GO_BEYOND_TERMINAL_TIME};
  
  // @end {instance variable or static variable} -------------------------
  
  
  // @begin {constructors} -----------------------------------------------
  
  /**
   * Creates a new default <code>TimeControl</code> instance.
   *
   */
  private TimeControl() {}

  // @end {constructors} -------------------------------------------------

  
  // @begin {methods} ----------------------------------------------------

  private Object readResolve() throws ObjectStreamException {
    return PRIVATE_VALUES[ordinal];
  }

  // @end {methods} ------------------------------------------------------

} // TimeControl
