/**
 * ohymosjMain.java
 *
 * Created: 2004/01/09
 *
 * @author <a href="mailto:satoh@wr.kuciv.kyoto-u.ac.jp">satoh</a>
 * @version $Revision: 1.25 $ $Date: 2004/02/07 08:25:21 $
 *
 * @(#)
 */

import java.io.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

import ohymosj.*;
import ohymosj.OhOption;

/**
 * OHyMoSJ is the Java version of OHyMoS. <p>
 *
 * @author <a href="mailto:satoh@wr.kuciv.kyoto-u.ac.jp">satoh</a>
 * @version $Revision: 1.25 $ $Date: 2004/02/07 08:25:21 $
 */

public class ohymosjMain {
  static String _version = "0.1";
  static final String NEWLINE = System.getProperty("line.separator");

  /**
   * main prints the version number of the OHyMoSJ.
   *
   * @param args[] a <code>String</code> value
   */
  public static void main(String args[]) {
    int num = args.length;
    OhOption op = OhOption.getDefault();
    for (int i = 0; i < num; i++) {
      if (args[i].equals("-w")) {
        op.setUseWinP(true);
      }
    }
 
    //; logo mark \ -------------------------------------------------
    boolean useWinP = op.getUseWinP();
    if (useWinP) {
      // When the user selects the window-based interface,
      // OhIcon is shown.
      //
      //; Window ʂďƂ肷Iꍇ́A
      //; OhWin \܂BOhWin ́Asingleton class ŁA
      //; OhWin.getDefault() ŁAOhWin  singleton 擾ł܂B
      //;
      OhWin ow = OhWin.getDefault();
      ow.setSize(200,50);
      ow.setMessage("OHyMoSJ " + "version " + _version);
      ow.setVisible(true);
    }
    else {
      // When the user selects the terminal-based interface.
      //
      //; ^[~i (R\[) ʂďƂ肷
      //;
      System.out.println("OHyMoSJ " + "version " + _version);
    }

    //; OHyMoSJ ̃CvO ----------------------------------------
    try {
      if (useWinP) {
        // JPanel pane = (JPanel)OhWin.getDefault().getContentPane();
        ImageIcon myIcon = new ImageIcon("khlogo.png");
        JOptionPane.showConfirmDialog(
          null,                        //; Parent frame.
          "܂vZ܂B",      //; Message.
          "OHyMoSJ",                   //; Title.
          JOptionPane.DEFAULT_OPTION,  //; Option type.
          JOptionPane.PLAIN_MESSAGE,   //; Message type.
          myIcon                       //; HY icon.
          );
        OhWin.getDefault().setMessage("Wait. Now, I am working.");
      }
      else {
        System.out.println("܂vZ܂BReturn L[ĂB");
        InputStreamReader isr = new InputStreamReader(System.in);
        BufferedReader br = new BufferedReader(isr);
        String ignore = br.readLine();
        System.out.println("Wait. Now, I am working.");
      }
//    Thread.sleep(4000);


//    System.out.println(args[0]);  --> total.scf
      
      OhScfTotalSystem totalSystem = new OhScfTotalSystem(args[0]);
      String fileBasepart = args[1];

      
      totalSystem.setOhymosjOption();

      if (totalSystem.construct() != true) {
        System.out.print(NEWLINE);
        System.out.print("# Failure : construct().");
        System.out.print(NEWLINE);
        System.exit(1);
      }

      if (totalSystem.canYouSwitch() != true) {
        System.out.print(NEWLINE);
        System.out.print("# Failure : canYouSwitch().");
        System.out.print(NEWLINE);
        System.exit(1);
      }

      if (totalSystem.areYouReady() != true) {
        System.out.print(NEWLINE);
        System.out.print("# Failure : areYouReady().");
        System.out.print(NEWLINE);
        System.exit(1);
      }

      String pmtFileName = fileBasepart + ".pmt";
      totalSystem.readParameterFile(pmtFileName);

      String istFileName = fileBasepart + ".ist";
      totalSystem.readInitialStateFile(istFileName);

      String isdFileName = fileBasepart + ".isd";
      totalSystem.readSendPortFile(isdFileName);

//;   totalSystem.doShareInfo();  //; KvH
      
      totalSystem.initialWork();

//;   System.out.println("Finish initialWork().");

      totalSystem.work();

      System.out.println("Finish simulation!");  //; mFpWo

      
      String tstFileName = fileBasepart + ".tst";
      totalSystem.writeTerminalState(tstFileName);

      String tsdFileName = fileBasepart + ".tsd";
      totalSystem.writeSendPortStock(tsdFileName);

      System.out.println("Finish saving!");  //; mFpWo

    }
//  catch (InterruptedException ignored) {
//  }
    catch (OhCannotGetDataError e) {
      System.out.println(e.what());
    }
    catch (OhError e) {
      System.out.println(e.what());
    }
    catch (IOException e) {
      e.printStackTrace();
    }
    catch (IllegalArgumentException e) {
      e.printStackTrace();
    }
    catch (ClassCastException e) {
      e.printStackTrace();
    }
    catch (NullPointerException e) {
      e.printStackTrace();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
    
    //; OHyMoSJ ̏I ------------------------------------------------

    if (useWinP) {
      //; System.exit ĂԂƁASwing ֌W̊IĂ܂B
      System.exit(0);
    }
  }
} // ohymosjMain
