/**
 * @(#) OhDataPackIntTest; class to test "OhDataPackInt"
 */

package ohymosj;

import ohymosj.*;
import junit.framework.*;
import java.io.*;


/*
  JUnit frame work

  1. Create a subclass of junit.framework.TestCase.
  2. Write initialization codes in the setUp() method.
  3. Write cleanup codes in the tearDown() method.
  4. Write a test method for the XXX method in public void test_XXX().
     Use assertEquals("---comments---", expected, actual) for testing.
*/

/**
 * OhDataPackIntTest;
 * <p>
 *
 * --descrition--
 *
 * @author <a href="mailto:satoh@CHAOPHRAYA"></a>
 * @version $Revision: 1.3 $ $Date: 2004/01/17 01:10:02 $
 */
public class OhDataPackIntTest extends TestCase {

  OhDataPackInt _a;
  OhDataPackInt _b;
  int _i;
  
  public OhDataPackIntTest(String name) {
    super(name);
  }

  protected void setUp() {
    _a = new OhDataPackInt();
    _i = 12;
    _b = new OhDataPackInt(new OhTimePoint(2003,1), _i);
  }

  protected void tearDown() {
  }

/*
  constructor ̃eXg
*/
  public void test_constructor() throws Exception {
    OhTimePoint dataTime = _a.getDataTime();
    int dataValue = _a.getDataValue();

    OhTimePoint expectedDataTime = new OhTimePoint();
    int expectedDataValue = 0;

    assertEquals("test default constructor 1", expectedDataTime, dataTime);
//  assertEquals("test default constructor", expectedDataTime.getDataTime(), dataTime); ͊ԈႢI
    assertEquals("test constructor", expectedDataValue, dataValue);
//  assertEquals("test default constructor 2", 0, dataValue); łnjI

    expectedDataTime = new OhTimePoint(2003, 1);
    expectedDataValue = _i;

    OhDataPackInt b = new OhDataPackInt(expectedDataTime, expectedDataValue);

    assertEquals("test constructor 1", expectedDataTime, b.getDataTime());
    assertEquals("test constructor 2", expectedDataValue, b.getDataValue());
  }
    
/*
  int getDataValue() ̃eXg
*/
  public void test_getDataValue() throws Exception {
    assertEquals("test getDataValue() 1", 0, _a.getDataValue());
    assertEquals("test getDataValue() 2", 12, _b.getDataValue());
//  assertEquals("test getDataValue() 2", _i, _b.getDataValue()); łnjI
  }

/*
  void getData(OhTimePoint aDataTime, int[] aDataValue) ̃eXg
*/
  public void test_getData() throws Exception {
    OhTimePoint expectedDataTime = new OhTimePoint(2003, 1);

    OhTimePoint tp = new OhTimePoint();
    int[] j = {0};
    _b.getData(tp, j);
    
    assertEquals("test getData() 1", expectedDataTime, tp);
    assertEquals("test getData() 2", 12              , j[0]);
  }

/*
  void setData(OhTimePoint aDataTime, int aDataValue) ̃eXg
*/
  public void test_setData() throws Exception {
    OhTimePoint expectedDataTime = new OhTimePoint(2003, 8);
//  int expectedDataValue = 34;
    
    _b.setData(expectedDataTime, 34);
    
    assertEquals("test setData() 1", expectedDataTime, _b.getDataTime());
    assertEquals("test setData() 2", 34              , _b.getDataValue());
  }
  
/*
  String dataType() ̃eXg
*/
  public void test_dataType() throws Exception {
    String expectedDataType = "int";

    assertEquals("test dataType", expectedDataType, _a.dataType());
    assertEquals("test dataType", expectedDataType, _b.dataType());
  }

/*
  dpack2Ofile(PrintWriter os) ̃eXg
*/
  public void test_dpack2Ofile() throws Exception {
//  PrintWriter pw = new PrintWriter(System.out, true);

//  assertEquals("test dpack2Ofile", System.out.print("2003 1 12"), _b.dpack2Ofile(pw));
//; void ^gp邱Ƃ͂łȂI


    ByteArrayOutputStream byteOutputStream = new ByteArrayOutputStream();
    System.setOut(new PrintStream(byteOutputStream));
//  _b.dpack2Ofile(pw);
    _b.dpack2Ofile(new PrintWriter(System.out, true));
    
//  System.out.print("2003 1 12");

//  byte buf[] = new byte[256];
//  byteOutputStream.write(buf, 0, 256);

//  byteOutputStream.close();
    
//  assertEquals("test dpack2Ofile", "2003 1 12" , byteOutputStream.toString());
//  assertEquals("dpack2Ofile() check", "2003 1 12", byteOutputStream.toString());
  }

/*
  dpack2File(PrintWriter os) ̃eXg
*/
  public void test_dpack2File() throws Exception {
//  PrintWriter pw = new PrintWriter(System.out, true);

    ByteArrayOutputStream byteOutputStream = new ByteArrayOutputStream();
    System.setOut(new PrintStream(byteOutputStream));
    _b.dpack2File(new PrintWriter(System.out, true));

//  private static final String LN = System.getProperty("line.separator");
    String LN = System.getProperty("line.separator");
    
//  assertEquals("(2003)" + LN + "(1)" + LN + "(12)" + LN , byteOutputStream.toString());
  }
}
