/**
 * @(#) OhObjectTest
 */

package ohymosj;

import ohymosj.*;
import junit.framework.*;
import java.io.*;

/*
  JUnit frame work

  1. Create a subclass of junit.framework.TestCase.
  2. Write initialization codes in the setUp() method.
  3. Write cleanup codes in the tearDown() method.
  4. Write a test method for the XXX method in public void test_XXX().
     Use assertEquals("---comments---", expected, actual) for testing.
*/

/**
 * OhObjectTest;
 * <p>
 *
 * --descrition--
 *
 * @author <a href="mailto:satoh@CHAOPHRAYA"></a>
 * @version $Revision: 1.3 $ $Date: 2003/12/07 14:58:54 $
 */
public class OhObjectTest extends TestCase {

  OhObject _b;  

  public OhObjectTest(String name) {
    super(name);
  }

  protected void setUp() {
    try {
      _b = new OhObject("Regacy", 7);
    }
    catch (OhError e) {
      e.printStackTrace();
    }
  }

  protected void tearDown() {
  }

  public void test_getClassName() {
//  String expected = "Object";
    String expected = "OhObject";

    String actual_2 = _b.getClassName();

    assertEquals("getClassName() check 2", expected, actual_2);
  }

  public void test_getObjectName() {
    String expected_2 = "Regacy";
    String actual_2 = _b.getObjectName();

    assertEquals("getClassName() check 2", expected_2, actual_2);
  }
    
  public void test_getObjectNumber() {
    int expected_2 = 7;
    int actual_2 = _b.getObjectNumber();

    assertEquals("getObjectNumber() check 2", expected_2, actual_2);
  }
    
  public void test_getOwner() {
    Object expected = null;

    Object actual_2 = _b.getOwner();

    assertEquals("getOwner() check 2", expected, actual_2);
//  assertEquals("getOwner() check 2", null, actual_2);  łnjI
  }

  public void test_setOwner() {
    OhObject oo = null;
    
    try {
      oo = new OhObject("Porsche", 1);

      _b.setOwner(oo);
    }
    catch (OhError e) {
      e.printStackTrace();
    }


    assertEquals("setOwner() check 2", oo, _b.getOwner());    
  }

  public void test_getTopOwner() {

    assertEquals("getTopOwner() check 2-1", _b, _b.getTopOwner());

    OhObject oo = null;

    try {
      oo = new OhObject("Porsche", 1);

      _b.setOwner(oo);
    }
    catch (OhError e) {
      e.printStackTrace();
    }


    assertEquals("getTopOwner() check 2-2", oo, _b.getTopOwner());
  }

  public void test_objCompare() {
//  assertEquals("objCompare() check 1-1-1", true,  _a.objCompare("Object", "", -1));
//  assertEquals("objCompare() check 1-1-2", false, _a.objCompare("Object", " ", -1));

    assertEquals("objCompare() check 1-2-1", true,  _b.objCompare("OhObject", "Regacy", 7));

    assertEquals("objCompare() check 1-2-2", false, _b.objCompare("OhObject", "", -1));

//  assertEquals("objCompare() check 2-1-1", true,  _a.objCompare("", -1));
//  assertEquals("objCompare() check 2-1-2", false, _a.objCompare(" ", -1));

    assertEquals("objCompare() check 2-2-1", true,  _b.objCompare("Regacy", 7));

    assertEquals("objCompare() check 2-2-2", false, _b.objCompare("", -1));


    OhObject oo      = null;
    OhObject dummy_b = null;
    
    try {
      oo = new OhObject("Porsche", 1);
//    _a.setOwner(oo);
//    OhObject dummy_a = new OhObject();
//    dummy_a.setOwner(oo);

//    assertEquals("objCompare() check 3-1", true, _a.objCompare(dummy_a));

      _b.setOwner(oo);
      
      dummy_b = new OhObject("Regacy", 7);
      dummy_b.setOwner(oo);
    }
    catch (OhError e) {
      e.printStackTrace();
    }

    assertEquals("objCompare() check 3-2", true, _b.objCompare(dummy_b));
  }

  public void test_getAbsName() {
    String expected_1 = "/__-1";
//  assertEquals("getAbsName() check 1", expected_1 , _a.getAbsName());
//  assertEquals("getAbsName() check 1", (Object)expected_1
//                 , (Object)_a.getAbsName()); łnjI
    
    OhObject oo = null;

    try {
      oo = new OhObject("Porsche", 1);
      
      _b.setOwner(oo);
    }
    catch (OhError e) {
      e.printStackTrace();
    }


//  assertEquals("getAbsName() check 2", "/Regacy__7" , _b.getAbsName());
    assertEquals("getAbsName() check 2", "/Porsche__1/Regacy__7", _b.getAbsName());
  }


/*
  cPrint(PrintWriter os, String aHead) ̃eXg
*/
  public void test_cPrint() {
    String LN = System.getProperty("line.separator");
    
//  ByteArrayOutputStream byteOutputStream = new ByteArrayOutputStream();
//  System.setOut(new PrintStream(byteOutputStream));
//  _a.cPrint((new PrintWriter(System.out, true)), "headOf_a");

//  assertEquals("cPrint() check 1", "headOf_aObject  -1" + LN, byteOutputStream.toString());

    ByteArrayOutputStream bos = new ByteArrayOutputStream();
    System.setOut(new PrintStream(bos));
/*
    PrintWriter pw = new PrintWriter(System.out, true);
    _b.cPrint(pw, "headOf_b");

    assertEquals("cPrint() check 2", "headOf_bObject Regacy 7" + LN, bos.toString());
*/
    System.out.println("foo");
    assertEquals("my test", "foo" + LN, bos.toString());

    StringWriter sw = new StringWriter();
    PrintWriter  pw = new PrintWriter(sw);
    _b.cPrint(pw, "headOf_b");
    assertEquals("cPrint() check 2", "headOf_bOhObject Regacy 7" + LN, sw.toString());
  }

/*
  oPrint(PrintWriter os, String aHead) ̃eXg
*/  
  public void test_oPrint() {
    String LN = System.getProperty("line.separator");

/*    
    ByteArrayOutputStream byteOutputStream = new ByteArrayOutputStream();
    System.setOut(new PrintStream(byteOutputStream));
//  _a.oPrint((new PrintWriter(System.out, true)), "headOf_a");

//  assertEquals("oPrint() check 1", "headOf_aObject  -1" + LN, byteOutputStream.toString());
    assertEquals("oPrint() check 1", "headOf_aOhObject  -1" + LN, byteOutputStream.toString());
*/
    

    OhObject oo = null;

    try {
      oo = new OhObject("Porsche", 1);
      _b.setOwner(oo);
    }
    catch (OhError e) {
      e.printStackTrace();
    }

/*    
    ByteArrayOutputStream bos = new ByteArrayOutputStream();
    System.setOut(new PrintStream(bos));
    _b.oPrint((new PrintWriter(System.out, true)), "headOf_b");
*/
    StringWriter sw = new StringWriter();
    PrintWriter  pw = new PrintWriter(sw);
    _b.oPrint(pw, "headOf_b");

    assertEquals("oPrint() check 1",
      "headOf_bOhObject Regacy 7" + LN + "headOf_b    _owner > OhObject Porsche 1" + LN,
      sw.toString());
  }
}

