package ohymosj;

import junit.framework.*;
import java.util.*;
import java.text.*;
import ohymosj.*;

/**
 * OhTimePointTest.java
 **
 * Created: Sat May 24 09:10:26 2003
 *
 * @author <a href="mailto:shiiba@mbox.kudpc.kyoto-u.ac.jp">shiiba</a>
 * @version
 */

public class OhTimePointTest extends TestCase {
  public OhTimePointTest (String name){
    super(name);
  }

  /*
    RXgN^
    OhTimePoint();
    OhTimePoint(int aYear, long aTsec);
    OhTimePoint(int aYear, int aMonth, int aDay,
                int aHour, int aMin, int aSec);
  */

  /*
    int getYear() ͐NԂ܂B    
   */
  public void testGetYear() throws Exception {
    OhTimePoint a = new OhTimePoint();
    assertEquals("Year check 1", 0, a.getYear());
    OhTimePoint b = new OhTimePoint(2003, 1);
    assertEquals("Year check 2", 2003, b.getYear());
    OhTimePoint c = new OhTimePoint(2003, 1, 1, 1, 1, 30);
    assertEquals("Year check 3", 2003, b.getYear());
  }

  /*
    long getTsec() ͔N̕bԂ܂B
  */
  public void testGetTsec() throws Exception {
    OhTimePoint a = new OhTimePoint();
    assertEquals("Tsec check 1", 0, a.getTsec());
    OhTimePoint b = new OhTimePoint(2003, 1);
    assertEquals("Tsec check 2", 1, b.getTsec());
    OhTimePoint c = new OhTimePoint(2003, 1, 1, 0, 1, 30);
    assertEquals("Tsec check 3", 90, c.getTsec());
  }

  /*
    public static boolean isLeapYear(int aYear) ̃eXg
    aYear 邤NȂ true Ԃ܂B
  */
  public void testIsLeapYearP() throws Exception {
    assertEquals("leapyear test 1", true, OhTimePoint.isLeapYear(2004));
    assertEquals("leapyear test 2", false, OhTimePoint.isLeapYear(2005));
  }

  /*
    public Object clone() ̃eXg
   */
  public void testClone() throws Exception {
    OhTimePoint a = new OhTimePoint(2003, 1, 1, 0, 0, 1);
    OhTimePoint b = (OhTimePoint)a.clone();
    assertEquals("clone test 1", 2003, b.getYear());
    assertEquals("clone test 2",    1, b.getTsec());
  }
  
  /*
    public boolean equals(Object arg) ̃eXg
   */
  public void testEquals() throws Exception {
    OhTimePoint a = new OhTimePoint(2003, 1, 1, 0, 1, 0);
    OhTimePoint b = new OhTimePoint(2003, 60);
    assertEquals("equals test 1", true, a.equals(b));
  }

  /*
    public long getOneYearInSec() ̃eXg.  1N̕bB
   */
  public void testGetOneYearInSec() throws Exception {
    OhTimePoint a = new OhTimePoint(2003, 1, 1, 0, 1, 0);
    assertEquals("oneYearInSec test", 365 * 24 * 3600, a.getOneYearInSec());
    OhTimePoint b = new OhTimePoint(2004, 0);
    assertEquals("oneYearInSec test", 366 * 24 * 3600, b.getOneYearInSec());
  }

  /*
    public Calendar toCalendarArray() ̃eXg
    toCalendarArray() ́ACalendar ^ɕϊ̂Ԃ܂B
   */
  public void testToCalendarArray() throws Exception {
    // DateFormat mdf = new SimpleDateFormat("yyyyMMddHHmmss");

    OhTimePoint ca = new OhTimePoint(2003, 1, 1, 0, 2, 0);
    int[] cala = ca.toCalendarArray();
    int[] calb = { 2003, 1, 1, 0, 2 , 0};

    long a = cala[0] + 1000*(cala[1]+100*(cala[2]+100*(cala[3]+100*(cala[4]+100*cala[5]))));
    long b = calb[0] + 1000*(calb[1]+100*(calb[2]+100*(calb[3]+100*(calb[4]+100*calb[5]))));
    
    assertEquals("toCalendarArray test", a, b);
  }

  /*
    OhTimePoint setYear(int aYear) ̃eXg
      setYear ́A_year ύX܂B
      _tsec ́A0 ɃZbg܂B
   */
  public void testSetYear() throws Exception {
    OhTimePoint a = new OhTimePoint(2003, 3, 1, 0, 0, 0);
    a.setYear(2004);
    assertEquals("setYear test 1", 2004, a.getYear());
    assertEquals("setYear test 2",   0L, a.getTsec());
  }
  
  /*
    OhTimePoint setTsec(long aTsec) ̃eXg
   */
  public void testSetTsec() throws Exception {
    OhTimePoint a = new OhTimePoint(2003, 3, 1, 0, 1, 0);
    a.setTsec(1000);
    assertEquals("setTsec test 1",  2003, a.getYear());
    assertEquals("setTsec test 2", 1000L, a.getTsec());
  }

  /*
    public int compareTo(object arg) ̃eXg
   */
  public void testCompareTo() {
    OhTimePoint a = new OhTimePoint(2003, 3, 1, 0, 1, 0);
    OhTimePoint b = new OhTimePoint(2004, 1, 2, 0, 1, 0);
    assertEquals("compareTo test 1", -1, a.compareTo(b));
    assertEquals("compareTo test 2",  0, a.compareTo(a));
    assertEquals("compareTo test 3",  1, b.compareTo(a));
  }

  /*
    public OhTimePoint add(long timeSec) ̃eXg

    this LĂ鎞 timeSec o߂ɕύX܂B
    timeSec ͕̒l̂Ƃ܂B
   */
  public void testAdd() {
    OhTimePoint a = new OhTimePoint(2003, 3, 1, 0, 1, 0);
    a.add(366*24*3600);
    OhTimePoint b = new OhTimePoint(2004, 3, 1, 0, 1, 0);
    assertEquals("add test", true, a.equals(b));
  }

  /*
    public String testToString() ̃eXg
      _year _tsec o܂
  */
  public void testToString() {
    OhTimePoint a = new OhTimePoint(2003, 1, 1, 0, 0, 30);
    assertEquals("toString test", (Object)"2003 30", a.toString());
  }

  /*
    public String toCalendarString() ̃eXg
      2003 12 30 12 30 12
   */
  public void testToCalendarString() {
    OhTimePoint a = new OhTimePoint(2003, 1, 1, 0, 0, 30);
    assertEquals("toCalendarString test",
      (Object)"20030101000030", a.toCalendarString());
  }
  
}// OhTimePointTest
